;
; Oliver Schmidt, 04.01.2005
;
; unsigned char get_ostype(void)
;

	.constructor	initostype
	.export		_get_ostype

; Identify machine according to:
; "Apple II Miscellaneous TechNote #7: Apple II Family Identification"

initostype:
	sec
	jsr	$FE1F
	bcs	nogs
	tya
	ora	#$80
	tay
	bmi	done		; Branch always
nogs:	ldx	#$00
next:	ldy	index,x
	beq	quit		; $00 is no valid index
	lda	value,x
	inx
	cmp	#$01		; $01 is no valid value
	beq	done
	cmp	$FB00,y
	beq	next
:	lda	value,x
	inx
	cmp	#$01		; $01 is no valid value
	bne	:-
	beq	next		; Branch always
done:	sty	ostype
quit:	rts

_get_ostype:
	lda	ostype
	ldx	#$00
	rts


	.rodata

index:	.byte	$B3, $10		; Apple ][
	.byte	$B3, $1E, $11		; Apple ][+
	.byte	$B3, $1E, $20		; Apple /// (emulation)
	.byte	$B3, $C0, $30		; Apple //e
	.byte	$B3, $C0, $DD, $BE, $40	; Apple //e Option Card
	.byte	$B3, $C0, $31		; Apple //e (enhanced)
	.byte	$B3, $C0, $BF, $50	; Apple //c
	.byte	$B3, $C0, $BF, $51	; Apple //c (3.5 ROM)
	.byte	$B3, $C0, $BF, $53	; Apple //c (Mem. Exp.)
	.byte	$B3, $C0, $BF, $54	; Apple //c (Rev. Mem. Exp.)
	.byte	$B3, $C0, $BF, $55	; Apple //c Plus
	.byte	$00

value:	.byte	$38, $01		; Apple ][
	.byte	$EA, $AD, $01		; Apple ][+
	.byte	$EA, $8A, $01		; Apple /// (emulation)
	.byte	$06, $EA, $01		; Apple //e
	.byte	$06, $E0, $02, $00, $01	; Apple //e Option Card
	.byte	$06, $E0, $01		; Apple //e (enhanced)
	.byte	$06, $00, $FF, $01	; Apple //c
	.byte	$06, $00, $00, $01	; Apple //c (3.5 ROM)
	.byte	$06, $00, $03, $01	; Apple //c (Mem. Exp.)
	.byte	$06, $00, $04, $01	; Apple //c (Rev. Mem. Exp.)
	.byte	$06, $00, $05, $01	; Apple //c Plus


	.bss

ostype:	.res	1
